; PATCH file A
; for Pac-Tape v1.0
; Copyright (C) 1997  by Sean Gugler
; a derivative work from M.A.M.E. v0.28
; Copyright (C) 1997  by Nicola Salmoria and the MAME team
;
; Modifies the following files:
;   makefile
;   src/drivers/pacman.c
;   src/vidhrdw/pengo.c
;   src/mame.c
;
;--------------------------------------------------------------------------
;
diff -rC2 s0/makefile s1/makefile
*** s0/makefile	Sun Sep  7 10:19:54 1997
--- s1/makefile	Fri Oct  3 17:12:50 1997
***************
*** 8,11 ****
--- 8,13 ----
  OBJS   = obj/mame.o obj/common.o obj/usrintrf.o obj/driver.o obj/cpuintrf.o obj/inptport.o \
           obj/osdepend.o \
+          obj/pactape/pactape.o obj/pactape/pactree.o obj/pactape/paclearn.o \
+          obj/pactape/pacthink.o \
           obj/sndhrdw/adpcm.o \
           obj/sndhrdw/ym2203.opm obj/sndhrdw/psg.o obj/sndhrdw/8910intf.o \
***************
*** 124,128 ****
           obj/M68000/cpufunc.o
  
! VPATH = src src/Z80 src/M6502 src/I86 src/M6809
  
  all: mame.exe
--- 126,130 ----
           obj/M68000/cpufunc.o
  
! VPATH = src src/Z80 src/M6502 src/I86 src/M6809 src/pactape
  
  all: mame.exe
***************
*** 143,146 ****
--- 145,152 ----
  obj/M6809/m6809.o:  m6809.c m6809.h 6809ops.c
  
+ obj/pactape/pactape.o:  pactape.c pacdefs.h
+ obj/pactape/paclearn.o: paclearn.c pactree.h pacdefs.h
+ obj/pactape/pactree.o:  pactree.c pactree.h pacdefs.h
+ obj/pactape/pacthink.o: pacdefs.h
  
  clean:
diff -rC2 s0/src/drivers/pacman.c s1/src/drivers/pacman.c
*** s0/src/drivers/pacman.c	Wed Oct  1 18:06:00 1997
--- s1/src/drivers/pacman.c	Thu Sep 18 17:05:30 1997
***************
*** 68,71 ****
--- 68,73 ----
  
  
+ int pactape_input_port_0_r(int offset);
+ int pactape_input_port_1_r(int offset);
  
  static struct MemoryReadAddress readmem[] =
***************
*** 74,79 ****
  	{ 0x4000, 0x47ff, MRA_RAM },	/* video and color RAM */
  	{ 0x4c00, 0x4fff, MRA_RAM },	/* including sprite codes at 4ff0-4fff */
! 	{ 0x5000, 0x503f, input_port_0_r },	/* IN0 */
! 	{ 0x5040, 0x507f, input_port_1_r },	/* IN1 */
  	{ 0x5080, 0x50bf, input_port_2_r },	/* DSW */
  	{ 0x8000, 0x9fff, MRA_ROM },	/* Ms. Pac Man only */
--- 76,81 ----
  	{ 0x4000, 0x47ff, MRA_RAM },	/* video and color RAM */
  	{ 0x4c00, 0x4fff, MRA_RAM },	/* including sprite codes at 4ff0-4fff */
! 	{ 0x5000, 0x503f, pactape_input_port_0_r },	/* IN0 */
! 	{ 0x5040, 0x507f, pactape_input_port_1_r },	/* IN1 */
  	{ 0x5080, 0x50bf, input_port_2_r },	/* DSW */
  	{ 0x8000, 0x9fff, MRA_ROM },	/* Ms. Pac Man only */
diff -rC2 s0/src/vidhrdw/pengo.c s1/src/vidhrdw/pengo.c
*** s0/src/vidhrdw/pengo.c	Fri Aug 29 15:43:16 1997
--- s1/src/vidhrdw/pengo.c	Wed Oct  1 17:30:04 1997
***************
*** 15,23 ****
  #include "vidhrdw/generic.h"
  
  
  
  static int gfx_bank;
  static int flipscreen;
! static int xoffsethack;
  
  
--- 15,25 ----
  #include "vidhrdw/generic.h"
  
+ void pactape_on_vh_update(struct osd_bitmap *bitmap);
  
  
  static int gfx_bank;
  static int flipscreen;
! static int xoffsethack = 239;
! static int pacgame;
  
  
***************
*** 114,118 ****
  	gfx_bank = 0;
  	flipscreen = 0;
! 	xoffsethack = 0;
  
  	return generic_vh_start();
--- 116,120 ----
  	gfx_bank = 0;
  	flipscreen = 0;
! 	pacgame = 0;
  
  	return generic_vh_start();
***************
*** 125,129 ****
  	/* In the Pac Man based games (NOT Pengo) the first two sprites must be offset */
  	/* one pixel to the left to get a more correct placement */
! 	xoffsethack = 1;
  
  	return generic_vh_start();
--- 127,136 ----
  	/* In the Pac Man based games (NOT Pengo) the first two sprites must be offset */
  	/* one pixel to the left to get a more correct placement */
! 	    /*\ CORRECTION: The first two *ghost monsters* (the red and pink ones) must be
! 	    |*|   offset one pixel to the left.  (reason unknown -- curse the programmers.)
! 	    |*| See comments in vh_screenrefresh, where pacgame is used.
! 	    |*| [Sean Gugler]
! 	    \*/
! 	pacgame = 1;
  
  	return generic_vh_start();
***************
*** 164,167 ****
--- 171,176 ----
  {
  	int offs;
+ 	static int ghost1=2;
+ 	static int ghost2=4;
  
  
***************
*** 224,233 ****
  	/* Draw the sprites. Note that it is important to draw them exactly in this */
  	/* order, to have the correct priorities. */
! 	for (offs = spriteram_size - 2;offs > 2*2;offs -= 2)
  	{
  		drawgfx(bitmap,Machine->gfx[1 + 2 * gfx_bank],
  				spriteram[offs] >> 2,spriteram[offs + 1],
  				spriteram[offs] & 2,spriteram[offs] & 1,
! 				239 - spriteram_2[offs],272 - spriteram_2[offs + 1],
  				&spritevisiblearea,TRANSPARENCY_COLOR,0);
  
--- 233,243 ----
  	/* Draw the sprites. Note that it is important to draw them exactly in this */
  	/* order, to have the correct priorities. */
! 	for (offs = spriteram_size - 2;offs >= 0;offs -= 2)
  	{
+ 		if (pacgame) xoffsethack = (offs == ghost1 || offs == ghost2) ? 238 : 239;
  		drawgfx(bitmap,Machine->gfx[1 + 2 * gfx_bank],
  				spriteram[offs] >> 2,spriteram[offs + 1],
  				spriteram[offs] & 2,spriteram[offs] & 1,
! 				xoffsethack - spriteram_2[offs],272 - spriteram_2[offs + 1],
  				&spritevisiblearea,TRANSPARENCY_COLOR,0);
  
***************
*** 237,260 ****
  				spriteram[offs] >> 2,spriteram[offs + 1],
  				spriteram[offs] & 2,spriteram[offs] & 1,
! 				239 - spriteram_2[offs],272-256 - spriteram_2[offs + 1],
  				&spritevisiblearea,TRANSPARENCY_COLOR,0);
  	}
  	/* In the Pac Man based games (NOT Pengo) the first two sprites must be offset */
  	/* one pixel to the left to get a more correct placement */
! 	for (offs = 2*2;offs >= 0;offs -= 2)
  	{
! 		drawgfx(bitmap,Machine->gfx[1 + 2 * gfx_bank],
! 				spriteram[offs] >> 2,spriteram[offs + 1],
! 				spriteram[offs] & 2,spriteram[offs] & 1,
! 				239 - xoffsethack - spriteram_2[offs],272 - spriteram_2[offs + 1],
! 				&spritevisiblearea,TRANSPARENCY_COLOR,0);
! 
! 		/* also plot the sprite 256 pixels higher for vertical wraparound (tunnel in */
! 		/* Crush Roller) */
! 		drawgfx(bitmap,Machine->gfx[1 + 2 * gfx_bank],
! 				spriteram[offs] >> 2,spriteram[offs + 1],
! 				spriteram[offs] & 2,spriteram[offs] & 1,
! 				239 - xoffsethack - spriteram_2[offs],272-256 - spriteram_2[offs + 1],
! 				&spritevisiblearea,TRANSPARENCY_COLOR,0);
  	}
  }
--- 247,277 ----
  				spriteram[offs] >> 2,spriteram[offs + 1],
  				spriteram[offs] & 2,spriteram[offs] & 1,
! 				xoffsethack - spriteram_2[offs],272-256 - spriteram_2[offs + 1],
  				&spritevisiblearea,TRANSPARENCY_COLOR,0);
  	}
  	/* In the Pac Man based games (NOT Pengo) the first two sprites must be offset */
  	/* one pixel to the left to get a more correct placement */
! 	if (pacgame)
  	{
! 	    /*\ CORRECTION: The first two *ghost monsters* (the red and pink ones) must be
! 	    |*|   offset one pixel to the left.  (reason unknown -- curse the programmers.)
! 	    |*| Sprite usage is actually manipulated to adjust priorities:
! 	    |*|   Normal assignment:   1 = red ghost, 2 = pink, 3 = blue, 4 = yellow,
! 	    |*|                        5 = Pac-Man, 6 = fruit  (0 and 7 unused)
! 	    |*|   During power-up:      swap 1 and 5 (draw pac-man over ghosts)
! 	    |*|   While eating a ghost: swap 2 and ghost being eaten (score must be visible)
! 	    |*|   NOTE: eating 2 == NOP, eating 1 == double-swap
! 	    |*| We can cheat and access Pac-Man RAM to determine these states:
! 	    |*|   0x4da6: flag, Pac-Man powered up (energy pill)
! 	    |*|   0x4dd1: flag, monster being eaten (show its score)
! 	    |*|   0x4da4: which monster being eaten (1,2,3,4 = red,pink,blue,yellow)
! 	    |*| However, these RAM flags are always one cycle ahead of video update;
! 	    |*|   thus, we read them in advance for the next round.
! 	    |*| [Sean Gugler]
! 	    \*/
! 	    ghost1 = (RAM[0x4da6]) ? 10 : 2;
! 	    ghost2 = (RAM[0x4dd1] && RAM[0x4da4]>2) ? RAM[0x4da4]*2 : 4;
  	}
+ 
+ 	pactape_on_vh_update(bitmap);
  }
diff -rC2 s0/src/mame.c s1/src/mame.c
*** s0/src/mame.c	Sun Sep  7 21:32:22 1997
--- s1/src/mame.c	Wed Oct  1 17:33:22 1997
***************
*** 82,86 ****
  	{
  		printf("M.A.M.E. v%s - Multiple Arcade Machine Emulator\n"
! 		       "Copyright (C) 1997  by Nicola Salmoria and the MAME team\n\n",mameversion);
  		showdisclaimer();
  		printf("Usage:  MAME gamename [options]\n");
--- 82,88 ----
  	{
  		printf("M.A.M.E. v%s - Multiple Arcade Machine Emulator\n"
! 		       "Copyright (C) 1997  by Nicola Salmoria and the MAME team\n\n"
!  		       "-- includes Pac-Tape v1.0 module: \"Tape\" recorder for Pac-Man games\n"
!  		       "Copyright (C) 1997  by Sean Gugler\n\n",mameversion);
  		showdisclaimer();
  		printf("Usage:  MAME gamename [options]\n");
